#ifndef __ASSERT
#define __ASSERT

#ifndef NDEBUG

asm(".set __assert_not_defined,1");
/* Indicate that assert support is not included yet */

#define assert(p) ({(p)?(void)0:__fail(#p,__FILE__,__LINE__); \
  asm(".if __assert_not_defined;" \
      ".set __assert_not_defined,0;" \
      "bra __askp;" \
  "__ttl:" \
      ".ascii \"ASSERTION FAILED\";" \
      "dc.w 0; __fmt: dc.b 10;" \
      ".ascii \" Condition: %s\";" \
      "dc.b 10,10;" \
      ".ascii \" File: %s  Line: %d\";" \
      "dc.w 0;" \
  "__fail:" \
      "link.w %a6,#-1044;" \
      "move.l 200.w,%a2;" \
      "move.w 16(%a6),(%sp);" \
      "move.l 12(%a6),-(%sp);" \
      "move.l 8(%a6),-(%sp);" \
      "pea __fmt;" \
      "lea -1000(%a6),%a4;" \
      "move.l %a4,-(%sp);" \
      "move.l 332(%a2),%a0;" \
      "jsr (%a0);" \
      "move.l 188(%a2),%a0;" \
      "clr.l %d0;" \
      "move.b 2(%a0),%d0;" \
      "swap %d0;" \
      "move.b 3(%a0),%d0;" \
      "add.l #0xFFF5FFF1,%d0;" \
      "move.l %d0,(%sp);" \
      "move.l #0xA000A,-(%sp);" \
      "move.l 176(%a2),%a0;" \
      "jsr (%a0);" \
      "pea __ttl;" \
      "move.w #0x1058,-(%sp);" \
      "move.l %a0,-(%sp);" \
      "pea -1042(%a6);" \
      "move.l 120(%a2),%a0;" \
      "jsr (%a0);" \
      "move.l 4(%a2),%a0;" \
      "jsr (%a0);" \
      "clr.w 4(%sp);" \
      "move.l 76(%a2),%a0;" \
      "jsr (%a0);" \
      "move.l %a4,4(%sp);" \
      "move.l 148(%a2),%a0;" \
      "jsr (%a0);" \
      "move.l #0x10008,4(%sp);" \
      "move.l 212(%a2),%a0;" \
      "jsr (%a0);" \
  "__wkey:" \
      "move.l 324(%a2),%a0;" \
      "jsr (%a0);" \
      "cmp.w  #13,%d0;" \
      "jbne __wkey;" \
      "move.l 44(%a2),%a0;" \
      "jsr (%a0);" \
  "__exlp:" \
      "unlk %a6;" \
      "cmpi.l #0x200000,(%sp);" \
      "bcs.s __exlp;" \
      "move.l (%a2,2472),%a2;" \
      "rts;" \
  "__askp: ;" \
      ".endif");})

#else
#define assert(p) ((void)0)
#endif

#endif
