#ifndef __VALUES
#define __VALUES

#define BITSPERBYTE 8

#define MAXSHORT 0x7FFF
#ifdef __INT_SHORT__
#define MAXINT 0x7FFF
#else
#define MAXINT 0x7FFFFFFFL
#endif
#define MAXLONG 0x7FFFFFFFL

#define HIBITS 0x8000
#ifdef __INT_SHORT__
#define HIBITI 0x8000
#else
#define HIBITI 0x80000000
#endif
#define HIBITL 0x80000000

#define DMAXEXP 999   /* Greater exponents are principally possible (up to */
#define FMAXEXP 999   /* 16383), but not supported in all math functions   */
#define DMINEXP -999
#define FMINEXP -999

#define MAXDOUBLE 9.999999999999999e999
#define MAXFLOAT 9.9999999999999e999
#define MINDOUBLE 1e-999
#define MINFLOAT 1e-999

#define DSIGNIF 64
#define FSIGNIF 56

#define DMAXPOWTWO 3321
#define FMAXPOWTWO 3321
#define _DEXPLEN 15
#define _FEXPLEN 15
#define _EXPBASE 10
#define _IEEE 0
#define LN_MAXDOUBLE 2303.58509299
#define LN_MINDOUBLE -2300.2825079

#endif
